(Optional) Bitsets
Author: Benjamin Qi
Prerequisites
- Errichto - Bitwise Operations Pt 1
Examples of how bitsets give some unintended solutions on recent USACO problems.
Tutorial
tl;dr some operations are around 32-64x faster compared to a boolean array. See the C++ Reference for the operations you can perform.
Resources | |||
---|---|---|---|
CPH | speeding up Hamming distance | ||
CF |
Knapsack
Focus Problem – read through this problem before continuing!
Of course, the first step is to generate the sizes of each connected component.
1#include <bits/stdc++.h>2using namespace std;34struct DSU {5 vector<int> e; void init(int N) { e = vector<int>(N,-1); }6 int get(int x) { return e[x] < 0 ? x : e[x] = get(e[x]); }7 bool sameSet(int a, int b) { return get(a) == get(b); }8 int size(int x) { return -e[get(x)]; }9 bool unite(int x, int y) { // union by size10 x = get(x), y = get(y); if (x == y) return 0;
A naive knapsack solution would be as follows. For each , let if there exists a subset of the first components whose sizes sum to . Then the answer will be stored in . This runs in and is too slow if implemented naively, but we can use bitset to speed it up!
Note: you can't store all bitsets in memory at the same time (more on that below).
Full Solution
Challenge: This solution runs in when and there are no edges. Find a faster solution which can also be sped up with bitset (my solution runs in 0.03s).
Cowpatibility (Gold)
Focus Problem – read through this problem before continuing!
Label the cows from . For two cows and set adj[x][y]=1
if they share a common flavor. Then the number of pairs of cows that are compatible (counting each pair where and are distinct twice) is equal to the sum of adj[x].count()
over all . It remains to compute adj[x]
for all .
Unfortunately, storing bitsets each with bits takes up bytes of memory, which is greater than USACO's megabyte limit. We can reduce the memory usage by half in exchange for a slight increase in time by first computing the adjacency bitsets for all , and then for all afterwards.
First, we read in all of the flavors.
1#include <bits/stdc++.h>2using namespace std;34typedef long long ll;5typedef bitset<50000> B;6const int HALF = 25000;78int N;9B adj[HALF];10vector<int> flav[1000001];
Then for each flavor, we can look at all pairs of cows that share that flavor and update the adjacency lists for those .
1int main() {2 input();3 for (int i = 1; i <= 1000000; ++i)4 for (int x: flav[i]) if (x < HALF)5 for (int y: flav[i]) adj[x][y] = 1;6 for (int i = 0; i < HALF; ++i) ans += adj[i].count();7}
adj[i].count()
runs quickly enough since its runtime is divided by the bitset constant. However, looping over all cows in flav[i]
is too slow if say, flav[i]
contains all cows. Then the nested loop could take time! Of course, we can instead write the nested loop in a way that takes advantage of fast bitset operations once again.
1for (int i = 1; i <= 1000000; ++i) if (flav[i].size() > 0) {2 B b; for (int x: flav[i]) b[x] = 1;3 for (int x: flav[i]) if (x < HALF) adj[x] |= b;4}
The full main function is as follows:
Full Solution
Apparently no test case contains more than distinct colors, so we don't actually need to split the calculation into two halves.
Lots of Triangles
Focus Problem – read through this problem before continuing!
First, we read in the input data. cross(a,b,c)
is positive iff c
lies to the left of the line from a
to b
.
1#include <bits/stdc++.h>2using namespace std;34typedef long long ll;5typedef pair<ll,ll> P;67#define f first8#define s second910ll cross(P a, P b, P c) {
There are possible lots. Trying all possible lots and counting the number of trees that lie within each in for a total time complexity of should solve somewhere between 2 and 5 test cases. Given a triangle t[0], t[1], t[2]
with positive area, tree x
lies within it iff x
is to the left of each of sides (t[0],t[1])
,(t[1],t[2])
, and (t[2],t[0])
.
1int main() {2 input();3 vector<int> res(N-2);4 for (int i = 0; i < N; ++i) for (int j = i+1; j < N; ++j)5 for (int k = j+1; k < N; ++k) {6 vector<int> t = {i,j,k};7 if (cross(v[t[0]],v[t[1]],v[t[2]]) < 0) swap(t[1],t[2]);8 int cnt = 0;9 for (int x = 0; x < N; ++x) {10 if (cross(v[t[0]],v[t[1]],v[x]) <= 0) continue;
The analysis describes how to count the number of trees within a lot in , which is sufficient to solve the problem. However, is actually sufficient as long as we divide by the bitset constant. Let b[i][j][k]=1
if k
lies to the left of side (i,j)
. Then x
lies within triangle (t[0],t[1],t[2])
as long as b[t[0]][t[1]][x]=b[t[1]][t[2]][x]=b[t[2]][t[0]][x]=1
. We can count the number of x
such that this holds true by taking the bitwise AND of the bitsets for all three sides and then counting the number of bits in the result.
Fast Solution
Knapsack Again
(GP of Bytedance 2020 F)
Given () positive integers (), find the max possible sum of a subset of whose sum does not exceed .
Consider the case when . The intended solution runs in ; see here for more information. However, we'll solve it with bitset instead.
As with the first problem in this module, let if there exists a subset of the first numbers components that sums to . This solution runs in time, which is too slow even if we use bitset.
Taking inspiration from this CF blog post, we'll first shuffle the integers randomly and perform the DP with the following modification:
- If for some that we choose, then set .
Since we only need to keep track of values for each , this solution runs in time, which is fast enough with using bitset.
It turns out that (up to a constant) suffices for correctness with high probability (briefly mentioned here). I'm not totally sure about the details, but intuitively, the random shuffle reduces the optimal subset to some distribution with variance at most . In the special case where each is either or , we can bound the probability of failure using the Catalan numbers. I think it is something like if we let the bitset have size .
Solution
Other Applications
Use to speed up the following:
- Gaussian Elimination in
- Bipartite matching in (dense graph with vertices on each side)
- Though Kuhn's algorithm is probably fast enough ...
- BFS through dense graph in
In general, passing solutions with an additional factor of .
Operations such as _Find_first()
and _Find_next()
mentioned in Errichto's blog can be helpful.
Resources | |||
---|---|---|---|
GFG | only resource I could find :P |
A comment regarding the last two applications:
In USACO Camp, a similar problem appeared with and a second time limit (presumably to allow solutions to pass). I had already done this problem but forgot how I had solved it decided to try something new. Try to guess what I did!
Problems
Status | Source | Problem Name | Difficulty | Tags | Solution | URL |
---|---|---|---|---|---|---|
TOKI | Easy | Show TagsBitset | Check TLX | |||
Baltic OI | Normal | Show TagsBitset | External Sol | |||
Baltic OI | Normal | Show TagsKnapsack, Bitset | ||||
COCI | Normal | Show TagsBitset | View Solution | |||
Plat | Hard | Show TagsBitset, Sliding Window | External Sol | |||
IZhO | Hard | Show TagsKnapsack, Bitset | View Solution | |||
Baltic OI | Hard | Show TagsKnapsack, Bitset | ||||
CF | Hard | Check CF |
Module Progress:
Join the USACO Forum!
Stuck on a problem, or don't understand a module? Join the USACO Forum and get help from other competitive programmers!